/*************************************************************/
/*                   VS1003                        */
/*  WinAVR 20060421                                      */
/*  ߣBozai䲨                                    */
/*  E-mailsudazqb@163.com                                  */
/*  20061126                                           */
/*************************************************************/
/*          VS1003 diriver for  MiniMP3 Player     *               */
/*                                                                 */
/* Platform   : AVRStudio4.12 sp4 + WinAVR20060421                 */
/*              optimize -0s                                       */
/* Author     : bozai(Zhang Qibo)                                  */
/* E-mail     : sudazqb@163.com                                    */
/* MSN        : zhangqibo_1985@hotmail.com                         */
/* Date       : 2006-12-26                                         */
/*******************************************************************/
#include<avr/io.h>
#include"VS1003B.h"

#define uchar unsigned char
#define uint  unsigned int

//ٶ	//low speed
void VS1003B_SPI_Low(void)
{
	SPCR =   _BV(SPE)|_BV(MSTR)|_BV(SPR1)|_BV(SPR0);
	SPSR &= ~_BV(SPI2X);
}

//FCK/4ٶ	//full speed
void VS1003B_SPI_High(void)
{
	SPCR =  _BV(SPE)|_BV(MSTR);
	//SPSR &= ~_BV(SPI2X);
	SPSR |= _BV(SPI2X);
}

//ʱ		//delay
void VS1003B_Delay( unsigned int n)
{
	while(n--);
}

//VS1003дһֽ		//write one byte to vs1003
unsigned char VS1003B_WriteByte(unsigned char CH)
{   
	SPDR = CH;
	while(!(SPSR & _BV(SPIF)));
	return SPDR;
}

//VS1003һֽ		//read one byte from vs1003
unsigned char VS1003B_ReadByte()
{
    SPDR = 0xff;
	while(!(SPSR & _BV(SPIF)));
	return SPDR;
}

//дĴַ	//config register
void VS1003B_WriteCMD(unsigned char addr, unsigned int dat)
{
	VS1003B_XDCS_H();
	VS1003B_XCS_L();
	VS1003B_WriteByte(0x02);
	VS1003B_WriteByte(addr);
	VS1003B_WriteByte(dat>>8);
	VS1003B_WriteByte(dat);
	VS1003B_XCS_H();
}

//Ĵ ַ 	//read register
unsigned int VS1003B_ReadCMD(unsigned char addr)
{
	unsigned int temp;
	VS1003B_XDCS_H();
	VS1003B_XCS_L();
	VS1003B_WriteByte(0x03);
	VS1003B_WriteByte(addr);
	temp = VS1003B_ReadByte();
	temp <<= 8;
	temp += VS1003B_ReadByte();
	VS1003B_XCS_H();
	return temp;
}

//дݣ		//write data (music data)
void VS1003B_WriteDAT(unsigned char dat)
{
	VS1003B_XDCS_L();
	VS1003B_WriteByte(dat);
	VS1003B_XDCS_H();
	VS1003B_XCS_H();
}

//VS1003ʼ0ɹ 1ʧ	//initialize VS1003
unsigned char VS1003B_Init()
{
	unsigned char retry;
	PORT_INI();
	VS1003B_DDR &=~_BV(VS1003B_DREQ);
	VS1003B_XCS_H();
	VS1003B_XCS_H();
	VS1003B_XRESET_L();
	VS1003B_Delay(0xffff);
	VS1003B_XRESET_H();//ʹоƬ	//chip select
	VS1003B_SPI_Low();//ԵƵ	//low speed
	VS1003B_Delay(0xffff);//ʱ	//delay
	retry=0;
	while(VS1003B_ReadCMD(0x00) != 0x0800)//дmodeĴ	//set mode register
	{
		VS1003B_WriteCMD(0x00,0x0800);
		if(retry++ >10 )break;//{PORTB|=_BV(PB1);break;}
	}
	retry=0;
	while(VS1003B_ReadCMD(0x03) != 0xc000)//дʱӼĴ	//set PLL register
	{
		VS1003B_WriteCMD(0x03,0xc000);
		if(retry++ >10 )break;
	}
	retry=0;
	while(VS1003B_ReadCMD(0x0b) != DefaultVolume)//	//set Volume
	{
		VS1003B_WriteCMD(0x0b,DefaultVolume);
		if(retry++ >10 )break;
	}
	VS1003B_SPI_High();//ٶȣȫ		//turn to high speed
	if(retry > 10)return 1;
	return 0;
}

//VS1003λ	//VS1003 soft reset
void VS1003B_SoftReset()
{
	VS1003B_WriteCMD(0x00,0x0804);//дλ		//reset
	VS1003B_Delay(0xffff);//ʱ1.35ms //wait at least 1.35ms
}


