/*******************************************************************/
/*                   MP3/Wma/Midi                            */
/*  ܣļϵͳΪFAT16/32SDĿ¼µMP3/Wma/Midļ    */
/*        ֱΪ ͣ/ ģʽ һ һ + -*/
/*  WinAVR 20060421                                            */
/*  ߣBozai䲨                                          */
/*  E-mailsudazqb@163.com                                        */
/*  20061213                                                 */
/*******************************************************************/
/*          MiniMP3 Player (mega8 + VS1003 + SD)  V2.0             */
/*                                                                 */
/* Discription: Can play mp3/wma/wav/mid SF0 files in the root     */
/*              directery on the SD card which file system is FAT16*/
/*              or FAT32.                                          */
/*              It has six keys to control this player             */
/*              MODE: switch between repet all (default),repet one */
/*                    and shuffle                                  */
/*              PLAY/PAUSE:                                        */
/*              PREV: previous songs                               */
/*              NEXT: next songs                                   */
/*              UP  : volume up                                    */
/*              DOWN: volume down                                  */
/* Platform   : AVRStudio4.12 sp4 + WinAVR20060421                 */
/*              optimize -0s                                       */
/* Author     : bozai(Zhang Qibo)                                  */
/* E-mail     : sudazqb@163.com                                    */
/* MSN        : zhangqibo_1985@hotmail.com                         */
/* Date       : 2006-12-29                                         */
/*******************************************************************/



#include<avr/io.h>
#include"MMC_SD/MMC_SD.h" //head files
#include"FAT/FAT.h"
#include"VS1003B/VS1003B.h"
#include<avr/pgmspace.h>

#define uint unsigned int

//diagnose and state indicate leds
//at start up this two led indicate error
//at normal they indicate the state of the MODE 
#define LED1_CON() DDRC|=_BV(PC5)
#define LED1_ON()  PORTC|=_BV(PC5)
#define LED1_OFF() PORTC&=~_BV(PC5)

#define LED2_CON() DDRB|=_BV(PB1)
#define LED2_ON()  PORTB|=_BV(PB1)
#define LED2_OFF() PORTB&=~_BV(PB1)

//keys
#define STOP _BV(PD2)
#define MODE _BV(PD3)
#define NEXT _BV(PD7)
#define UP   _BV(PD4)
#define DOWN _BV(PD6)
#define PREV _BV(PD5)

#define MP3 1
#define WMA 2
#define MID 3

//mode
#define REPET_ALL 0
#define REPET_ONE 1
#define RANDOM    2

extern WORD SectorsPerClust;//ÿ
extern WORD FirstDataSector;//һ   //struct of file information
extern BYTE FAT32_Enable;

struct FileInfoStruct FileInfo;//ļϢ

struct direntry MusicInfo;	//Ҫŵmp3ļϢ		//the mp3 file item whichi will be played
uint16 totalsongs;			//ܵļĿ			//total songs in the root directery on the SD card
uint8 type;					//ļ					//file type



void Delay(uint16 n)//ʱ
{
	while(n--);
}

//Timer initialization offer seed of the srandom()
void Timer1_Initial()
{
 TCNT1H=0x00;
 TCNT1L=0x00;
 TCCR1A=0x03;//ctc mode  use icr1
 TCCR1B=0x01;//system clock;
 ICR1H=0xff;
 ICR1L=0xff;
}

void PlayMusicwithKey()//ֺһִв˳
{
	uint16 keylen;			//ڼ		//for key processing
	uint16 count;			//ݼ			//data counting
	uint8 i;				//ѭ			//loop variable
	uint16 j;				//ѭ			//loop variable
	DWORD p;				//ָʾֵ			//cluster
	DWORD totalsect;		//ļӵе	//cotain the total sector number of a file
	uint16 leftbytes;		//ʣֽ			//cotain the left bytes number of a file //the last cluster usually not fully occupied by the file
	uint8 *buffer;			//				//buffer
	DWORD sector;			//				//recor the current sector to judge the end sector
	uint8 flag;				///ͣ־		//flag of pause
	uint16 vol=DefaultVolume;//ʼӦvs1003ĳʼͬ	//default volume
	uint8 songs=1;			//ĬϷŵһ׸	//play the fist songs by default
	uint8 mode=0;			//ظ			//repet all by default
	if(totalsongs==0)return;//ûи쳣˳	//if no music file return
	unsigned long rand_val;
	Timer1_Initial();//ʱڲ	//initialize the timer
next://һ׸ʼط						//label for "goto"
	if(mode==RANDOM)//Ÿ 				//if the mode is shuffle the songs
	{
		rand_val = TCNT1;
		Delay((random() && 0x00ff));
		rand_val <<= 16;
		rand_val += TCNT1;
		srandom(rand_val);
		songs = (unsigned int)(((random()/214749)*(unsigned long)totalsongs)/10000)+1;//	//create random song number
	}
	count=0;//	//clear count
	flag=1;
	while(count<2048 && (type != MID))//recommand 2048 zeros honoring DREQ befor soft reset
	{									//ڴwmaһ׸裬һ׸//midiʽҪ
		if((VS1003B_PIN & _BV(VS1003B_DREQ))!=0)
		{
			for(j=0;j<32;j++)
			{
				VS1003B_WriteDAT(0x00);//0	//fill 0
				count++;
			}
			if(count == 2047)break;
		}
	}
	VS1003B_SoftReset();//soft reset //in case of playing wma files//λ
	Search("\\",&MusicInfo,&songs,&type);		//ҵӦļ		//find the file
	p     = MusicInfo.deStartCluster+(((unsigned long)MusicInfo.deHighClust)<<16);//ļ״	//the first cluster of the file
		
	totalsect = MusicInfo.deFileSize/512; //			//calculate the total sectors
	leftbytes = MusicInfo.deFileSize%512; //ʣֽ	//calculate the left bytes	
	i=0;
	sector=0;
	
	while(1)
	{
		keylen=0;
    	for(;i<SectorsPerClust;i++)		//һ	//a cluster
		{
			buffer=malloc(512);
			FAT_LoadPartCluster(p,i,buffer);//һ	//read a sector
			count=0;
			while(count<512)
			{
				if(flag==0){if(keylen){Delay(100);keylen--;}}
				else if(type == MID){if(keylen){Delay(100);keylen--;}}
				if((VS1003B_PIN & _BV(VS1003B_DREQ))!=0 && flag)	//Ҫ  //send data  honoring DREQ
				{
					for(j=0;j<32;j++)			//ÿ32		//32 Bytes each time
					{
						VS1003B_WriteDAT(buffer[count]);
						count++;
					}
					if(keylen)keylen--;			//ڼ			//for key processing
					if(sector == totalsect && count >= leftbytes)		//ļѽ		//if this is the end of the file
					{
						if(type == MID)//waiting the midi file was decoded
						{//midҪ2048
							count=0;
							while(count<2048)//recommand 2048 zeros honoring DREQ goto next songs
							{
								if((VS1003B_PIN & _BV(VS1003B_DREQ))!=0 )
								{
									for(j=0;j<32;j++)
									{
										VS1003B_WriteDAT(0x00);
										count++;
									}
									if(count == 2047)break;
								}
							}
						}
						i=SectorsPerClust;
						break;
					}//ļ			//file ended
					if(count == 511){break;}//512ֽ		//break if a sector was sent
				}
				if((PIND&STOP)==0 /*&& keylen==0*/)//ͣ		//key PLAY/PAUSE
			    {
	 			    Delay(100);
					if(!(PIND&STOP))
					{
						while(!(PIND&STOP));
						 if(flag)flag=0;
						 else flag=1;
						 Delay(1000);
					 }
				 }
				else if(!(PIND&DOWN) && keylen==0)  //-			//Volume down
	 			{
				    Delay(100);
	   			 	if(!(PIND&DOWN))  
					{
					keylen=200;
					   vol=vol+((uint)(1<<8)+1);
					   if(vol>=0xFEFE) vol=0xFEFE; 
	   			       else VS1003B_WriteCMD(0x0b,vol);
					 }
	 			 }
				 else if(!(PIND&UP) && keylen==0) //+			//Volume up
	  			 {
					 Delay(100);
				 	 if(!(PIND&UP)) 
					 {
					 keylen=200;
					   vol=vol-((uint)(1<<8)+1);
					   if(vol<=0x0101) vol=0x0101;
					   else VS1003B_WriteCMD(0x0b,vol);
	   			     }
				  }
				 else if(!(PIND&NEXT)) //һ						next songs
	 			 {
					Delay(50000);		
					if(!(PIND&NEXT))
					{
						while(!(PIND&NEXT));
						songs++;
						if(songs > totalsongs)songs=1;
						{
							free(buffer);
							goto next;
						}
					}
	  			 }
				 else if(!(PIND&PREV)) //һ						previous songs
	 			 {
					Delay(5000);		
					if(!(PIND&PREV))
					{
						while(!(PIND&PREV));
						if(songs == 1)songs=totalsongs;
						else songs--;
						{
							free(buffer);
							goto next;
						}
					}
	  			 }
				 else if((!(PIND&MODE)) && keylen==0) //ģʽ			//mode key
	 			 {
					Delay(100);		
					if(!(PIND&MODE))
					{
						keylen=0xffff;
						if(mode==REPET_ALL)
						{
							mode=REPET_ONE;
							LED1_ON();
							LED2_OFF();
						}
						else if(mode==REPET_ONE)//next mode is shuffle
						{
							mode=RANDOM;
							LED1_OFF();
							LED2_ON();
							srandom(((unsigned long)TCNT1)<<16);//
						}
						else 
						{
							mode=REPET_ALL;
							LED1_OFF();
							LED2_OFF();
						}
					}
	  			 }
			}
			sector++;
			free(buffer);
		}
		i=0;
		p=FAT_NextCluster(p);//һ			//read next cluster
		if(p == 0x0fffffff || p == 0x0ffffff8 || (FAT32_Enable == 0 && p == 0xffff))//޺	//no more cluster
		{
				if(mode==REPET_ALL)songs++;
				if(songs>totalsongs)songs=1;
				goto next;
		}
	}
}

//main function
int main()
{
	DDRD &= 0x03;//ʼ˿
	PORTD |= 0xfc;
	
	LED1_CON();
	LED1_OFF();
	LED2_CON();
	LED2_OFF();


	OSCCAL = 0x00;//СRCƵ	//in order to operate some low speed card the initialization should run at lowest speed

	Delay(0xffff);

	MMC_SD_Init();//ʼspi		//SPI initialize

	Delay(0xffff);

	if(VS1003B_Init())LED1_ON();//VS1003	//config vs1003

	Delay(0xffff);//ṩ㹻ʱ				//supply enough delay
	Delay(0xffff);
	Delay(0xffff);
	Delay(0xffff);
	Delay(0xffff);

	MMC_SD_Reset();//ʼSD					//sd card initialize

	OSCCAL = 0xff;//RCƵ				//normal operation maximum the frequency

	Delay(0xffff);								//wait for stable

	if(FAT_Init())LED2_ON();//ʼļϵͳ ֧FAT16FAT32	//initialize file system  FAT16 and FAT32 are supported

	Search("\\",&MusicInfo,&totalsongs,&type);//Ŀµĸ Ŀ¼
	//Ҳָļ Search("\\new\\mp3",&MusicInfo,&totalsongs,&type);
	//ڸĿ¼µnewļµmp3ļµļ

	//search the songs in the root directery on the SD card
	//You can also specify the directery where the songs are placed
	//eg: Search("\\new\\mp3",&MusicInfo,&totalsongs,&type);
	//		means search the file in the foler C:\new

	PlayMusicwithKey();//Ÿ		//play songs
	return 0;
}




